#pragma once

// Mostly taken from depecher
// https://github.com/blacksailer/depecher/blob/master/depecher/src/DBusAdaptor.hpp

#include <QGuiApplication>
#include <QObject>
#include <QQuickView>

namespace spoon {
QQuickView *showApp(QGuiApplication *);
}

class DBusActivator : public QObject
{
    Q_OBJECT
    QGuiApplication *app = nullptr;
    QQuickView *view = nullptr;

public:
  explicit DBusActivator(QGuiApplication *parent = nullptr);
  ~DBusActivator();
  static bool isRegistered();
  static bool raiseApp();
signals:

public slots:
  void showApp();
  void openRoom(const QString &chatId);
private slots:
    void onViewDestroyed();
    void onViewClosing(QQuickCloseEvent *v);
};

